package com.jasamedika.medifirst2000.controller;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.domain.Specifications;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.IBaseRestController;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.entities.MapProdukMenuToBahan;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.MapProdukMenuToBahanService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.MapProdukMenuToBahanVO;

import net.kaczmarzyk.spring.data.jpa.domain.Equal;
import net.kaczmarzyk.spring.data.jpa.web.annotation.Spec;

@RestController
@RequestMapping(value="/menu-to-bahan")
public class MapProdukMenuToBahanController extends LocaleController<MapProdukMenuToBahanVO>
implements IBaseRestController<MapProdukMenuToBahanVO>{

	@Autowired
	private MapProdukMenuToBahanService mapService;
	
	private static final Logger LOGGER = LoggerFactory
			.getLogger(IndikatorRensarController.class);
	
	
	@RequestMapping(value="/find-all/", method= RequestMethod.GET,produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Collection<MapProdukMenuToBahan>> findAll(
			@RequestParam(value = "page", required = false, defaultValue = "0") Integer page,
			@RequestParam(value = "take", required = false, defaultValue = "100") Integer take,
			@RequestParam(value = "sort", required = false, defaultValue = "id") String sort,
			@RequestParam(value = "dir", required = false, defaultValue = "asc") String dir,
			@RequestParam(value = "menuId", required = true) Integer menuId)
	{
			Map<String, Object> result = new HashMap<String, Object>();
//			result = mapService.findAll(page, take, sort,dir, spec);
			result = mapService.findAll(page, take, sort, dir, menuId);
			return constructListPageResult(result);
	}

	@RequestMapping(value="/get-menu-gizi/", method= RequestMethod.GET,produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> findMenuGizi(
			HttpServletRequest request)
	{
			Map<String, Object> result = new HashMap<String, Object>();
			result = mapService.findMenuGizi();
			 if (null != result)
				   mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
	}
	
	@RequestMapping(value="/get-bahan-gizi/", method= RequestMethod.GET,produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> findBahanGizi(
			HttpServletRequest request)
	{
			Map<String, Object> result = new HashMap<String, Object>();
			result = mapService.findBahanGizi();
			 if (null != result)
				   mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
	}
	
	@RequestMapping(value="/save/", method= RequestMethod.POST,produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> save(@Valid @RequestBody List<MapProdukMenuToBahanVO> vo,HttpServletRequest request){
		try{
			Map<String, Object> result = mapService.save(vo);
			if(null!= result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS,request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
			
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add/update Menu To Bahan", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
			
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add/update Menu To Bahan", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
		
	}
	
	@Override
	public ResponseEntity<Collection<MapProdukMenuToBahanVO>> getAllVOWithQueryString(HttpServletRequest request,
			Integer page, Integer limit, String sort, String dir) {
		return null;
	}

	@Override
	public ResponseEntity<MapProdukMenuToBahanVO> getVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<String> addVO(MapProdukMenuToBahanVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> editVO(MapProdukMenuToBahanVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> deleteVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<List<MapProdukMenuToBahanVO>> getAllVO() {
		return null;
	}

	
}
